libstdc++: __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer > Class Template Reference

libstdc++

__gnu_debug::_Safe_local_iterator< _Iterator, _UContainer > Class Template Reference

`#include <safe_local_iterator.h>`

Inheritance diagram for __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >:
[legend]

## Public Types
typedef _Traits::difference_type | difference_type
typedef _Traits::iterator_category | iterator_category
typedef _Iterator | iterator_type
typedef _Traits::pointer | pointer
typedef _Traits::reference | reference
typedef _Traits::value_type | value_type

## Public Member Functions
| _Safe_local_iterator () noexcept
| _Safe_local_iterator (_Iterator __i, const _Safe_unordered_container_base *__cont)
| _Safe_local_iterator (_Safe_local_iterator &&__x) noexcept
| _Safe_local_iterator (const _Safe_local_iterator &__x) noexcept
template<typename _MutableIterator>
| _Safe_local_iterator (const _Safe_local_iterator< _MutableIterator, typename __gnu_cxx::__enable_if< _IsConstant::__value &&std::__are_same< _MutableIterator, _OtherIterator >::__value, _UContainer >::__type > &__x) noexcept
void | _M_attach (const _Safe_unordered_container_base *__cont)
void | _M_attach_single (const _Safe_unordered_container_base *__cont)
bool | _M_attached_to (const _Safe_sequence_base *__seq) const
bool | _M_can_compare (const _Safe_iterator_base &__x) const noexcept
bool | _M_dereferenceable () const
_Distance_traits< _Iterator >::__type | _M_get_distance_to (const _Safe_local_iterator &__rhs) const
std::__conditional_t< _IsConstant::__value, const _UContainer *, _UContainer * > | _M_get_ucontainer () const
template<typename _Other>
bool | _M_in_same_bucket (const _Safe_local_iterator< _Other, _UContainer > &__other) const
bool | _M_incrementable () const
void | _M_invalidate ()
bool | _M_is_begin () const
bool | _M_is_end () const
void | _M_reset () noexcept
const _Safe_unordered_container_base * | _M_safe_container () const noexcept
bool | _M_singular () const noexcept
void | _M_unlink () noexcept
bool | _M_valid_range (const _Safe_local_iterator &__rhs, std::pair< difference_type, _Distance_precision > &__dist_info) const
bool | _M_value_initialized () const
const _Iterator & | base () const noexcept
_Iterator & | base () noexcept
size_type | bucket () const
| operator _Iterator () const
reference | operator* () const
_Safe_local_iterator & | operator++ ()
_Safe_local_iterator | operator++ (int)
pointer | operator-> () const
_Safe_local_iterator & | operator= (_Safe_local_iterator &&__x) noexcept
_Safe_local_iterator & | operator= (const _Safe_local_iterator &__x)

## Static Public Member Functions
static constexpr bool | _S_constant ()

## Public Attributes
_Safe_iterator_base * | _M_next
_Safe_iterator_base * | _M_prior
const _Safe_sequence_base * | _M_sequence
unsigned int | _M_version

## Protected Member Functions
void | _M_attach (const _Safe_sequence_base *__seq, bool __constant)
void | _M_attach (const _Safe_unordered_container_base *__cont, bool __constant)
void | _M_attach_single (const _Safe_sequence_base *__seq, bool __constant) noexcept
void | _M_attach_single (const _Safe_unordered_container_base *__cont, bool __constant) noexcept
void | _M_detach ()
void | _M_detach_single () noexcept
__gnu_cxx::__mutex & | _M_get_mutex () noexcept

## Friends
bool | operator!= (const _Self &__lhs, const _OtherSelf &__rhs) noexcept
bool | operator!= (const _Self &__lhs, const _Self &__rhs) noexcept
bool | operator== (const _Self &__lhs, const _OtherSelf &__rhs) noexcept
bool | operator== (const _Self &__lhs, const _Self &__rhs) noexcept

## Detailed Description

template<typename _Iterator, typename _UContainer>
class __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >

Safe iterator wrapper.

The class template _Safe_local_iterator is a wrapper around an iterator that tracks the iterator's movement among unordered containers and checks that operations performed on the "safe" iterator are legal. In additional to the basic iterator operations (which are validated, and then passed to the underlying iterator), _Safe_local_iterator has member functions for iterator invalidation, attaching/detaching the iterator from unordered containers, and querying the iterator's state.

Definition at line 64 of file safe_local_iterator.h.

## Member Typedef Documentation

## ◆ difference_type

template<typename _Iterator, typename _UContainer>

typedef _Traits::difference_type __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::difference_type

Definition at line 93 of file safe_local_iterator.h.

## ◆ iterator_category

template<typename _Iterator, typename _UContainer>

typedef _Traits::iterator_category __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::iterator_category

Definition at line 91 of file safe_local_iterator.h.

## ◆ iterator_type

template<typename _Iterator, typename _UContainer>

typedef _Iterator __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::iterator_type

Definition at line 90 of file safe_local_iterator.h.

## ◆ pointer

template<typename _Iterator, typename _UContainer>

typedef _Traits::pointer __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::pointer

Definition at line 95 of file safe_local_iterator.h.

## ◆ reference

template<typename _Iterator, typename _UContainer>

typedef _Traits::reference __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::reference

Definition at line 94 of file safe_local_iterator.h.

## ◆ value_type

template<typename _Iterator, typename _UContainer>

typedef _Traits::value_type __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::value_type

Definition at line 92 of file safe_local_iterator.h.

## Constructor & Destructor Documentation

## ◆ _Safe_local_iterator() [1/5]

template<typename _Iterator, typename _UContainer>

__gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::_Safe_local_iterator | ( |  | ) |
| inlinenoexcept

Postcondition
  the iterator is singular and unattached

Definition at line 98 of file safe_local_iterator.h.

## ◆ _Safe_local_iterator() [2/5]

template<typename _Iterator, typename _UContainer>

__gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::_Safe_local_iterator | ( | _Iterator | __i,
|  | const _Safe_unordered_container_base * | __cont )
| inline

Safe iterator construction from an unsafe iterator and its unordered container.

Precondition
  `cont` is not NULL

Postcondition
  this is not singular

Definition at line 107 of file safe_local_iterator.h.

## ◆ _Safe_local_iterator() [3/5]

template<typename _Iterator, typename _UContainer>

__gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::_Safe_local_iterator | ( | const _Safe_local_iterator< _Iterator, _UContainer > & | __x | ) |
| inlinenoexcept

Copy construction.

Definition at line 115 of file safe_local_iterator.h.

## ◆ _Safe_local_iterator() [4/5]

template<typename _Iterator, typename _UContainer>

__gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::_Safe_local_iterator | ( | _Safe_local_iterator< _Iterator, _UContainer > && | __x | ) |
| inlinenoexcept

Move construction.

Postcondition
  __x is singular and unattached

Definition at line 132 of file safe_local_iterator.h.

## ◆ _Safe_local_iterator() [5/5]

template<typename _Iterator, typename _UContainer>
template<typename _MutableIterator>

__gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::_Safe_local_iterator | ( | const _Safe_local_iterator< _MutableIterator, typename __gnu_cxx::__enable_if< _IsConstant::__value &&std::__are_same< _MutableIterator, _OtherIterator >::__value, _UContainer >::__type > & | __x | ) |
| inlinenoexcept

Converting constructor from a mutable iterator to a constant iterator.

Definition at line 151 of file safe_local_iterator.h.

## Member Function Documentation

## ◆ _M_attach() [1/3]

void __gnu_debug::_Safe_iterator_base::_M_attach | ( | const _Safe_sequence_base * | __seq,
|  | bool | __constant )
| protectedinherited

Attaches this iterator to the given sequence, detaching it from whatever sequence it was attached to originally. If the new sequence is the NULL pointer, the iterator is left unattached.

References _M_attach().

Referenced by _Safe_iterator_base(), _Safe_iterator_base(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_attach(), and _M_attach().

## ◆ _M_attach() [2/3]

template<typename _Iterator, typename _UContainer>

void __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::_M_attach | ( | const _Safe_unordered_container_base * | __cont | ) |
| inline

Attach iterator to the given unordered container.

Definition at line 319 of file safe_local_iterator.h.

Referenced by __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_Safe_local_iterator(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_Safe_local_iterator(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_Safe_local_iterator(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=().

## ◆ _M_attach() [3/3]

void __gnu_debug::_Safe_local_iterator_base::_M_attach | ( | const _Safe_unordered_container_base * | __cont,
|  | bool | __constant )
| protectedinherited

Attaches this iterator to the given container, detaching it from whatever container it was attached to originally. If the new container is the NULL pointer, the iterator is left unattached.

Referenced by _Safe_local_iterator_base(), _Safe_local_iterator_base(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_M_attach().

## ◆ _M_attach_single() [1/3]

void __gnu_debug::_Safe_iterator_base::_M_attach_single | ( | const _Safe_sequence_base * | __seq,
|  | bool | __constant )
| protectednoexceptinherited

Likewise, but not thread-safe.

References _M_attach_single().

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_attach_single(), and _M_attach_single().

## ◆ _M_attach_single() [2/3]

template<typename _Iterator, typename _UContainer>

void __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::_M_attach_single | ( | const _Safe_unordered_container_base * | __cont | ) |
| inline

Likewise, but not thread-safe.

Definition at line 324 of file safe_local_iterator.h.

## ◆ _M_attach_single() [3/3]

void __gnu_debug::_Safe_local_iterator_base::_M_attach_single | ( | const _Safe_unordered_container_base * | __cont,
|  | bool | __constant )
| protectednoexceptinherited

Likewise, but not thread-safe.

Referenced by __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_M_attach_single().

## ◆ _M_attached_to()

bool __gnu_debug::_Safe_iterator_base::_M_attached_to | ( | const _Safe_sequence_base * | __seq | ) | const
| inlineinherited

Determines if we are attached to the given sequence.

Definition at line 161 of file safe_base.h.

References _M_attached_to(), and _M_sequence.

Referenced by _M_attached_to().

## ◆ _M_can_compare()

bool __gnu_debug::_Safe_iterator_base::_M_can_compare | ( | const _Safe_iterator_base & | __x | ) | const
| noexceptinherited

Can we compare this iterator to the given iterator `__x`? Returns true if both iterators are nonsingular and reference the same sequence.

References _Safe_iterator_base(), and _M_can_compare().

Referenced by _M_can_compare().

## ◆ _M_dereferenceable()

template<typename _Iterator, typename _UContainer>

bool __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::_M_dereferenceable | ( |  | ) | const
| inline

Is the iterator dereferenceable?

Definition at line 329 of file safe_local_iterator.h.

Referenced by __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator*(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator->().

## ◆ _M_detach()

void __gnu_debug::_Safe_local_iterator_base::_M_detach | ( |  | ) |
| protectedinherited

Detach the iterator for whatever container it is attached to, if any.

Referenced by __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_Safe_local_iterator(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=().

## ◆ _M_detach_single()

void __gnu_debug::_Safe_local_iterator_base::_M_detach_single | ( |  | ) |
| protectednoexceptinherited

Likewise, but not thread-safe.

## ◆ _M_get_distance_to()

template<typename _Iterator, typename _Sequence>

_Distance_traits< _Iterator >::__type __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_get_distance_to | ( | const _Safe_local_iterator< _Iterator, _UContainer > & | __rhs | ) | const

Definition at line 36 of file safe_local_iterator.tcc.

## ◆ _M_get_mutex()

__gnu_cxx::__mutex & __gnu_debug::_Safe_iterator_base::_M_get_mutex | ( |  | ) |
| protectednoexceptinherited

For use in _Safe_iterator.

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator++(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator++(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=().

## ◆ _M_get_ucontainer()

template<typename _Iterator, typename _UContainer>

std::__conditional_t< _IsConstant::__value, const _UContainer *, _UContainer * > __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::_M_get_ucontainer | ( |  | ) | const
| inline

Definition at line 355 of file safe_local_iterator.h.

## ◆ _M_in_same_bucket()

template<typename _Iterator, typename _UContainer>
template<typename _Other>

bool __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::_M_in_same_bucket | ( | const _Safe_local_iterator< _Other, _UContainer > & | __other | ) | const
| inline

Is this iterator part of the same bucket as the other one?

Definition at line 375 of file safe_local_iterator.h.

## ◆ _M_incrementable()

template<typename _Iterator, typename _UContainer>

bool __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::_M_incrementable | ( |  | ) | const
| inline

Is the iterator incrementable?

Definition at line 334 of file safe_local_iterator.h.

Referenced by __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator++(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator++().

## ◆ _M_invalidate()

void __gnu_debug::_Safe_iterator_base::_M_invalidate | ( |  | ) |
| inlineinherited

Invalidate the iterator, making it singular.

Definition at line 176 of file safe_base.h.

References _M_invalidate(), and _M_version.

Referenced by _M_invalidate().

## ◆ _M_is_begin()

template<typename _Iterator, typename _UContainer>

bool __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::_M_is_begin | ( |  | ) | const
| inline

Is this iterator equal to the container's begin(bucket) iterator?

Definition at line 365 of file safe_local_iterator.h.

## ◆ _M_is_end()

template<typename _Iterator, typename _UContainer>

bool __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::_M_is_end | ( |  | ) | const
| inline

Is this iterator equal to the container's end(bucket) iterator?

Definition at line 369 of file safe_local_iterator.h.

Referenced by __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_M_dereferenceable(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_M_incrementable().

## ◆ _M_reset()

void __gnu_debug::_Safe_iterator_base::_M_reset | ( |  | ) |
| noexceptinherited

Reset all member variables

## ◆ _M_safe_container()

const _Safe_unordered_container_base * __gnu_debug::_Safe_local_iterator_base::_M_safe_container | ( |  | ) | const
| inlinenoexceptinherited

Definition at line 219 of file safe_unordered_base.h.

## ◆ _M_singular()

bool __gnu_debug::_Safe_iterator_base::_M_singular | ( |  | ) | const
| noexceptinherited

Is this iterator singular?

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_Safe_local_iterator(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_Safe_local_iterator(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_Safe_local_iterator(), __gnu_debug::__check_singular_aux(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_dereferenceable(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_M_dereferenceable(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_M_incrementable(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_M_incrementable(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=().

## ◆ _M_unlink()

void __gnu_debug::_Safe_iterator_base::_M_unlink | ( |  | ) |
| inlinenoexceptinherited

Unlink itself

Definition at line 185 of file safe_base.h.

References _M_next, _M_prior, and _M_unlink().

Referenced by _M_unlink().

## ◆ _M_valid_range()

template<typename _Iterator, typename _Sequence>

bool __gnu_debug::_Safe_local_iterator< _Iterator, _Sequence >::_M_valid_range | ( | const _Safe_local_iterator< _Iterator, _UContainer > & | __rhs,
|  | std::pair< difference_type, _Distance_precision > & | __dist_info ) const

Definition at line 77 of file safe_local_iterator.tcc.

## ◆ _M_value_initialized()

template<typename _Iterator, typename _UContainer>

bool __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::_M_value_initialized | ( |  | ) | const
| inline

Is the iterator value-initialized?

Definition at line 339 of file safe_local_iterator.h.

Referenced by __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_Safe_local_iterator(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_Safe_local_iterator(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_Safe_local_iterator(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=().

## ◆ _S_constant()

template<typename _Iterator, typename _UContainer>

constexpr bool __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::_S_constant | ( |  | ) |
| inlinestaticconstexpr

Determine if this is a constant iterator.

Definition at line 293 of file safe_local_iterator.h.

Referenced by __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_M_attach(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_M_attach_single().

## ◆ base() [1/2]

template<typename _Iterator, typename _UContainer>

const _Iterator & __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::base | ( |  | ) | const
| inlinenoexcept

Definition at line 303 of file safe_local_iterator.h.

## ◆ base() [2/2]

template<typename _Iterator, typename _UContainer>

_Iterator & __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::base | ( |  | ) |
| inlinenoexcept

Return the underlying iterator.

Definition at line 300 of file safe_local_iterator.h.

Referenced by __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_Safe_local_iterator(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_M_is_begin(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_M_is_end(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_M_value_initialized(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::bucket(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator*(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator++(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator->(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=().

## ◆ bucket()

template<typename _Iterator, typename _UContainer>

size_type __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::bucket | ( |  | ) | const
| inline

Return the bucket.

Definition at line 309 of file safe_local_iterator.h.

Referenced by __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_M_in_same_bucket(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_M_is_begin(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::_M_is_end().

## ◆ operator _Iterator()

template<typename _Iterator, typename _UContainer>

__gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::operator _Iterator | ( |  | ) | const
| inline

Conversion to underlying non-debug iterator to allow better interaction with non-debug containers.

Definition at line 315 of file safe_local_iterator.h.

## ◆ operator*()

template<typename _Iterator, typename _UContainer>

reference __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::operator* | ( |  | ) | const
| inline

Iterator dereference.

Precondition
  iterator is dereferenceable

Definition at line 237 of file safe_local_iterator.h.

## ◆ operator++() [1/2]

template<typename _Iterator, typename _UContainer>

_Safe_local_iterator & __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::operator++ | ( |  | ) |
| inline

Iterator preincrement.

Precondition
  iterator is incrementable

Definition at line 264 of file safe_local_iterator.h.

## ◆ operator++() [2/2]

template<typename _Iterator, typename _UContainer>

_Safe_local_iterator __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::operator++ | ( | int |  | ) |
| inline

Iterator postincrement.

Precondition
  iterator is incrementable

Definition at line 279 of file safe_local_iterator.h.

## ◆ operator->()

template<typename _Iterator, typename _UContainer>

pointer __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::operator-> | ( |  | ) | const
| inline

Iterator dereference.

Precondition
  iterator is dereferenceable

Definition at line 250 of file safe_local_iterator.h.

## ◆ operator=() [1/2]

template<typename _Iterator, typename _UContainer>

_Safe_local_iterator & __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::operator= | ( | _Safe_local_iterator< _Iterator, _UContainer > && | __x | ) |
| inlinenoexcept

Move assignment.

Postcondition
  __x is singular and unattached

Definition at line 203 of file safe_local_iterator.h.

## ◆ operator=() [2/2]

template<typename _Iterator, typename _UContainer>

_Safe_local_iterator & __gnu_debug::_Safe_local_iterator< _Iterator, _UContainer >::operator= | ( | const _Safe_local_iterator< _Iterator, _UContainer > & | __x | ) |
| inline

Copy assignment.

Definition at line 172 of file safe_local_iterator.h.

## Friends And Related Symbol Documentation

## ◆ operator!= [1/2]

template<typename _Iterator, typename _UContainer>

bool operator!= | ( | const _Self & | __lhs,
|  | const _OtherSelf & | __rhs )
| friend

Definition at line 394 of file safe_local_iterator.h.

## ◆ operator!= [2/2]

template<typename _Iterator, typename _UContainer>

bool operator!= | ( | const _Self & | __lhs,
|  | const _Self & | __rhs )
| friend

Definition at line 401 of file safe_local_iterator.h.

## ◆ operator== [1/2]

template<typename _Iterator, typename _UContainer>

bool operator== | ( | const _Self & | __lhs,
|  | const _OtherSelf & | __rhs )
| friend

Definition at line 380 of file safe_local_iterator.h.

## ◆ operator== [2/2]

template<typename _Iterator, typename _UContainer>

bool operator== | ( | const _Self & | __lhs,
|  | const _Self & | __rhs )
| friend

Definition at line 387 of file safe_local_iterator.h.

## Member Data Documentation

## ◆ _M_next

_Safe_iterator_base* __gnu_debug::_Safe_iterator_base::_M_next
| inherited

Pointer to the next iterator in the sequence's list of iterators. Only valid when _M_sequence != NULL.

Definition at line 76 of file safe_base.h.

Referenced by _Safe_iterator_base(), _Safe_iterator_base(), _Safe_iterator_base(), __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if(), and _M_unlink().

## ◆ _M_prior

_Safe_iterator_base* __gnu_debug::_Safe_iterator_base::_M_prior
| inherited

Pointer to the previous iterator in the sequence's list of iterators. Only valid when _M_sequence != NULL.

Definition at line 72 of file safe_base.h.

Referenced by _Safe_iterator_base(), _Safe_iterator_base(), _Safe_iterator_base(), __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if(), and _M_unlink().

## ◆ _M_sequence

const _Safe_sequence_base* __gnu_debug::_Safe_iterator_base::_M_sequence
| inherited

The sequence this iterator references; may be NULL to indicate a singular iterator. Stored as pointer-to-const because sequence could be declared as const.

Definition at line 59 of file safe_base.h.

Referenced by __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::_Safe_iterator(), _Safe_iterator_base(), _Safe_iterator_base(), _Safe_iterator_base(), _M_attached_to(), __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_iterator< _Base_iterator, map >::operator=(), __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=(), and __gnu_debug::_Safe_local_iterator< _OtherIterator, _UContainer >::operator=().

## ◆ _M_version

unsigned int __gnu_debug::_Safe_iterator_base::_M_version
| inherited

The version number of this iterator. The sentinel value 0 is used to indicate an invalidated iterator (i.e., one that is singular because of an operation on the container). This version number must equal the version number in the sequence referenced by _M_sequence for the iterator to be non-singular.

Definition at line 68 of file safe_base.h.

Referenced by _Safe_iterator_base(), _Safe_iterator_base(), _Safe_iterator_base(), _M_invalidate(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_from_if().

The documentation for this class was generated from the following files:

- formatter.h
- safe_local_iterator.h
- safe_local_iterator.tcc